﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace csharp2vala
{
    class FileFunctions
    {

        public String[] readFilenamesToStringArray(String strDir, String suffix)
        {

            String[] myListRet = new String[0];
 
            int c;

            String[] myDirList = Directory.GetFileSystemEntries(strDir);

            //-- find out number of matching files --
            c = 0;
            foreach (string str in myDirList)
            {
                if(0 == (File.GetAttributes(str) & FileAttributes.Directory)){
                    if(str.Substring(str.Length - suffix.Length).Equals(suffix)){
                        c++;
                    }
                }
            }

            //log("--------" + c);

            //-- add matching files to array --
            String[] myList = new String[c+1];
            c = 0;
            foreach (string str in myDirList)
            {
                if (0 == (File.GetAttributes(str) & FileAttributes.Directory))
                {
                    if(str.Substring(str.Length - suffix.Length).Equals(suffix)){
                        myList[c] = str;
                        //log("test --- " + str + "--<");
                        c++;
                    }
                }
            }


            return (myList);

        }

        public string GetFileName(string thefile)
        {
            return (Path.GetFileName(thefile));
        }

        public void CreateDirectory(string thedir)
        {
            Directory.CreateDirectory(thedir);
        }

        public void WriteAllText(String strFile, String mystring)
        {
  
            File.WriteAllText(strFile, mystring);


        }


        public void WriteAllLines(String strFile, String[] myList)
        {
            //strFile = strFile.Trim();
            File.WriteAllLines(strFile , myList);

            /*
            for (int n = 0; n < myList.Length; n++)
            {

                log(myList[n]);
            }
            */

        }

        public String[] ReadAllLines(String strFile)
        {



            String[] myListRet = new String[0];


            if (!File.Exists(strFile))
            {
                log("File not found error!");
                return (myListRet);
            }

            String[] myList = File.ReadAllLines(strFile);
            return (myList);

            /*
                        String[] myList;
                        string lineInput;
                        StreamReader sr;

                        int lineCounter = 0; 
             
                        //-- check number of lines --

                        sr = File.OpenText(strFile);




                        lineInput = sr.ReadLine();
                        while (lineInput != null)
                        {
                            lineInput = sr.ReadLine();
                            lineCounter++;
                        }
                        sr.Close();

                        //-- read file to array --

                        myList = new String[lineCounter];
                        //myList[0] = "" + lineCounter;
                        lineCounter = 0;

                        sr = File.OpenText(strFile);
                        lineInput = sr.ReadLine();
                        while (lineInput != null)
                        {
                            lineInput = sr.ReadLine();
                            myList[lineCounter] = lineInput;
                            lineCounter++;
                        }
                        sr.Close();
               return (myList);
            */




        }


        //-- some helper methods for shorter code --

        public void log(String thetext)
        {
            Program.form1.textBox2.AppendText(thetext + "\r\n");
            cprint(thetext);
        }

        public void cprint(String thetext)
        {
            Console.WriteLine(thetext);
        }


    }
}
