﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Collections;

namespace csharp2vala
{
    class Convertproject
    {
        //-- a wrapper class for file related methods --
        private FileFunctions FF = new FileFunctions();
        private Glade glade = new Glade();
        //-- the project folder to convert --
        public String projectFolder;
        //-- where to create /vala-out/ --
        public String outPath;
        //-- this will contain the final filenames of the vala project --
        ArrayList valaProjectFiles;



        public void start()
        {

            //projectFolder = "C:/testprojects/WindowsFormsApplication1/WindowsFormsApplication1";

            //outPath = "C:/testprojects/WindowsFormsApplication1/valaout";
			
			
			
            projectFolder = "/root/testprojects/WindowsFormsApplication1/WindowsFormsApplication1";

            outPath = "/root/testprojects/WindowsFormsApplication1/valaout";
			

            valaProjectFiles = new ArrayList();
            String[] myFiles;
            String theLine;

           
            FF.log("Convertproject: starting...");

            myFiles = FF.readFilenamesToStringArray(projectFolder , ".cs");
            //foreach (string theLine in myFiles)
            for(int n=0; n<myFiles.Length-1;n++)
            {
                theLine = myFiles[n];

                convertFile(theLine);

            }
            build_vide(projectFolder);

            glade.FormToGlade(projectFolder , outPath);

            FF.log("");
            FF.log("Convertproject: finished!");
        }

        public void build_vide(String projectFolder)
        {

            String vide = FF.GetFileName(projectFolder);
            String videfile;

            videfile = outPath + "/" + vide + ".vide";
            FF.log("");
            FF.log("-> " + projectFolder);
            FF.log("--> " + vide);
            FF.log("--> " + videfile);

            String l;
            l = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
            l += "<project>";
            l += "<name>";
            l += vide;
            l += "</name>";
            l += "<files>";

            for (int i = 0; i < valaProjectFiles.Count; i++)
            {
                if(! valaProjectFiles[i].Equals("Form1.Designer.vala")){
                    l += "<file>";
                    l += valaProjectFiles[i];
                    l += "</file>";
                }
            }
            l += "</files>";
            l += "<compiler><pkg>gtk+-2.0</pkg><options></options></compiler><author/><version/><license>None</license>";
            l += "</project>";
            
            FF.WriteAllText(videfile, l);



        }        

        public void convertFile(String theFile){

            String fileName;
            String outFile;

            int c=0;

            fileName = FF.GetFileName(theFile);

            FF.CreateDirectory(outPath);

            outFile = fileName;
            outFile = outFile.Replace(".cs", ".vala");
            outFile = outFile.Replace("Program.vala", "main.vala");
            valaProjectFiles.Add(outFile);
            outFile = outPath + "/" + outFile;

            FF.log("processing: " + theFile);

            String[] myList = FF.ReadAllLines(theFile);
 
            ArrayList outListArray = new ArrayList();

            FF.log("" + myList.Length);

            String theLine;

            outListArray.Add("using Gtk;");
            c=1;

            for(int n=0; n<myList.Length;n++)
            {
                theLine = myList[n];


                ArrayList newLines = convertline(theLine, fileName);

                for(int i=0; i<newLines.Count;i++){

                    outListArray.Add(newLines[i].ToString());
                    c++;
                }
            }
            String[] outList = (string[])outListArray.ToArray(typeof(string));
            FF.WriteAllLines(outFile, outList);
        }

        public ArrayList convertline(String theLine, String fileName)
        {
            ArrayList li = new ArrayList();
            String newLine = theLine;

            if (theLine.Equals("")){
                li.Add("");
                return li;
            }

            String oldLine = newLine;

            newLine = newLine.Replace("Console.WriteLine(" , "print( \"%s\\n\", ");

            newLine = newLine.Replace("using", "//C2V//using");

            newLine = newLine.Replace("partial class", "class");




            //-- forms --

            if(fileName.Equals("Program.cs")){

                

                newLine = newLine.Replace(" Main()", " main()");

                newLine = newLine.Replace("Application.EnableVisualStyles();", "//C2V//Application.EnableVisualStyles();");

                newLine = newLine.Replace("Application.SetCompatibleTextRenderingDefault(false);", "//C2V//Application.SetCompatibleTextRenderingDefault(false);");

                newLine = newLine.Replace("Application.Run(new Form1());", "//C2V//Application.Run(new Form1());");
            }

            if(fileName.Equals("Form1.cs")){

                newLine = newLine.Replace("class Form1 : Form", "class Form1");

                newLine = newLine.Replace("InitializeComponent();", "//C2V//InitializeComponent();");

                newLine = newLine.Replace("object sender, EventArgs e", "Widget sender");
            }


            if(! newLine.Equals(oldLine)){
                if (!newLine.Contains("//C2V//"))
                {
                    li.Add("//C2V//" + oldLine);

                }
            }

            li.Add(newLine);
            return li;
        }

    }
}
